unit iado;

interface

uses
    Windows, Classes, SysUtils, ActiveX, ComObj, Variants;

//-----------------------------------------------------------------------------
type
    //  ڑEؒfNX
    TAdoxJetBase = class
    private
        FOpened: Boolean;
    protected
        FCNN: OleVariant;
        FCAT: OleVariant;
    public
        constructor Create();
        destructor Destroy(); override;
        procedure OpenConnection(const Path, Pass: string);
        procedure CloseConnection();
        function this(): TAdoxJetBase;
        property Opened: Boolean read FOpened;
        property CNN: OleVariant read FCNN;
        property CAT: OleVariant read FCAT;
    end;

    //  ̓NX
    TAdoxJetHtml = class(TAdoxJetBase)
    private
        F: TextFile;
        FStrings: TStrings;

        FTablePK: TStringList;
        FTableFK: TStringList;
        FTableUK: TStringList;
        FTableMisc: TStringList;
        FTableIndex: TStringList;

        procedure DoMessage(const Msg: string; const Level: Byte = 0);
        procedure DoAnalyzeFile(const OutPath, FileName, Password: string);

        procedure PutHtmlHead(const FileName: string);
        procedure PutTableItiran(const TABLES: OleVariant);
        procedure PutTableDetail(const TABLES: OleVariant);
        procedure PrepareTableSub(const TABLE: OleVariant);
        procedure PutConnectionProp();
        procedure PutHtmlFoot();
    public
        procedure DoAnalyze(const OutPath: string; Strings: TStrings);
        constructor Create();
        destructor Destroy(); override;
    end;

implementation

uses
    StrUtils, iadodata, iadoconst;

(*
    =================================================
    "<"">""&"AHTMLŐ\邽߂̕ϊ
    =================================================
*)
function ChangeHTMLSpecialChar(text: string): string;
var
    i: integer;
    src, dest: array[0..2] of string;
begin
    //"&"ŏɕϊƂȂƑςȂƂ
    src[0] := '&';  dest[0] := '&amp;';
    src[1] := '<';  dest[1] := '&lt;';
    src[2] := '>';  dest[2] := '&gt;';
    //ϊRs[
    Result := Text;
    //bAfor i := 0 to 2 do
    for i := Low(src) to High(src) do
    begin
        //uĂ邾
        Result := StringReplace(Result, src[i], dest[i], [rfReplaceAll]);
    end;
end;

//  ###########################################################################
//  TAdoxJetBase
//  ###########################################################################

//-----------------------------------------------------------------------------
//  RXgN^
constructor TAdoxJetBase.Create();
begin
    inherited;
    FOpened := false;
    FCNN := Unassigned;
    FCAT := Unassigned;
end;

//-----------------------------------------------------------------------------
//  fXgN^
destructor TAdoxJetBase.Destroy();
begin
    CloseConnection();
    inherited;
end;

//-----------------------------------------------------------------------------
//  gԂ
function TAdoxJetBase.this(): TAdoxJetBase;
begin
    Result := Self;
end;

//-----------------------------------------------------------------------------
//  ڑ쐬
function JetOleDbConnectionString(const Path, User, Pass: string): string;
const
    PARTS: array[0..2] of string
    = ('Data Source="%s";', 'User ID="%s";', 'Jet OLEDB:Database Password="%s";');
begin
    Result := 'Provider=Microsoft.Jet.OLEDB.4.0;';
    Result := Format('%s' + PARTS[0], [Result, Path]);
    if (User <> '') then Result := Format('%s' + PARTS[1], [Result, User]);
    if (Pass <> '') then Result := Format('%s' + PARTS[2], [Result, Pass]);
end;

//-----------------------------------------------------------------------------
//  ڑ
procedure TAdoxJetBase.OpenConnection(const Path, Pass: string);
begin
    try
        FCAT := CreateOleObject('ADOX.Catalog');
        FCAT.ActiveConnection := JetOleDbConnectionString(Path, '', Pass);
        FCNN := FCAT.ActiveConnection;
        FOpened := true;
    except
        raise;
    end;
end;

//-----------------------------------------------------------------------------
//  ؒf
procedure TAdoxJetBase.CloseConnection();
begin
    if FOpened then
    begin
        FCNN.Close;
        FCNN := UnAssigned;
        FCAT := UnAssigned;
        FOpened := false;
    end;
end;


//  ###########################################################################
//  TAdoxJetHtml
//  ###########################################################################

//-----------------------------------------------------------------------------
//  bZ[Wo
constructor TAdoxJetHtml.Create();
begin
    inherited;
    FTablePK := TStringList.Create;
    FTableFK := TStringList.Create;
    FTableUK := TStringList.Create;
    FTableMisc := TStringList.Create;
    FTableIndex := TStringList.Create;
end;

//-----------------------------------------------------------------------------
//  bZ[Wo
destructor TAdoxJetHtml.Destroy();
begin
    FTablePK.Free;
    FTableFK.Free;
    FTableUK.Free;
    FTableMisc.Free;
    FTableIndex.Free;
    inherited;
end;

//-----------------------------------------------------------------------------
//  bZ[Wo
procedure TAdoxJetHtml.DoMessage(const Msg: string; const Level: Byte = 0);
const
    S_LEVEL = '  ';
var
    T: string;
begin
    T := FormatDateTime('hh:nn:ss', Now());
    FStrings.Add(Format('%s %s%s', [T, DupeString(S_LEVEL, Level), Msg]));
end;

//-----------------------------------------------------------------------------
//  ̓Gg[
procedure TAdoxJetHtml.DoAnalyze(const OutPath: string; Strings: TStrings);
var
    Tick: Cardinal;
    i, Count: integer;
    MdbInfo: TMdbFile;
begin
    FStrings := Strings;
    try
        Tick := GetTickCount();
        DoMessage('͂Jn܂B');
        DoMessage(StringOfChar('-', 50));
        Count := MdbFiles.Count;

        for i := 0 to Count - 1 do
        begin
            //  t@CNXo
            MdbInfo := TMdbFile(MdbFiles[i]);
            DoMessage(Format('[%2d/%2d] ͊Jn %s', [i + 1, Count, MdbInfo.DispName]));

            //  ڑmFς݂̏ꍇ̂
            if (MdbInfo.Status = fsNoProblem) then
            begin
                ForceDirectories(OutPath);
                DoAnalyzeFile(OutPath, MdbInfo.FileName, MdbInfo.Password);
            end
            else
            begin
                DoMessage('ڑ`FbN̂߃X[܂B');
            end;
        end;

        DoMessage(StringOfChar('-', 50));
        Tick := GetTickCount() - Tick;
        DoMessage(Format('v %.3fb', [Tick / 1000]));
    finally
    end;

end;

//-----------------------------------------------------------------------------
//  (1t@C)
procedure TAdoxJetHtml.DoAnalyzeFile(const OutPath, FileName, Password: string);
label
    HELL_HELL_HELL;
var
    OutFile: string;
//    i, j, k, TableCount, ViewCount: integer;
//    TABLE, COLUMN, VIEW, PROP, KEY, IDX: OleVariant;
begin
    //  o͐挈
    OutFile := OutPath + ExtractFileName(ChangeFileExt(FileName, '.html'));

    try
        //  ڑ
        OpenConnection(FileName, Password);
        DoMessage('ڑ܂B', 1);
        try
            try
                //  t@CJ
                AssignFile(F, OutFile);
                Rewrite(F);
                try
                    //   HTMLwb_o
                    PutHtmlHead(FileName);

                    //   e[uꗗo
                    DoMessage('e[uꗗo͒...', 1);
                    PutTableItiran(CAT.Tables);

                    //   tB[h\o
                    DoMessage('tB[h\o͒...', 1);
                    PutTableDetail(CAT.Tables);

                    //   ڑvpeBo
                    DoMessage('ڑ̃vpeBo͒...', 1);
                    PutConnectionProp();

                    //   HTMLtb^o
                    PutHtmlFoot();
                finally
                    //  t@C
                    CloseFile(F);
                end;
            except
                on E:Exception do DoMessage(E.Message, 1);
            end;
        finally
            //  ؒf
            CloseConnection();
            DoMessage('ؒf܂B', 1);
        end;
    except
        on E:Exception do DoMessage(E.Message, 1);
    end;
(*
        try

            //  =====================================================
            //   5 
            //  r[邩ǂ`FbN
            ViewCount := CAT.Views.Count;
            //  ΂̏XLbv
            if (ViewCount = 0) then goto HELL_HELL_HELL;

            DoMessage('r[ꗗo͒...', 1);
            Writeln(F, '<h2>r[ꗗ</h2>');
            Writeln(F, '<p><table border=1 cellpadding=3 cellspacing=0>');
            //  <TABLE>̌Œ^Cg쐬
            Writeln(F, '<tr><th nowrap>NO</th><th nowrap>r[</th><th nowrap>쐬</th><th nowrap>XV</th>');
            Writeln(F, '</tr>');
            //  r[̃vpeBo
            for i := 0 to ViewCount - 1 do
            begin
                //  r[IuWFNgo
                VIEW := CAT.Views.Item[i];
                Writeln(F, '<tr>');
                //  ŒvpeBo
                Writeln(F, Format('<td nowrap>%d</td>', [i + 1]));
                Writeln(F, Format('<td nowrap>%s</td>', [VIEW.Name]));
                Writeln(F, Format('<td nowrap>%s</td>', [VarToStr(VIEW.DateCreated)]));
                Writeln(F, Format('<td nowrap>%s</td>', [VarToStr(VIEW.DateModified)]));
                Writeln(F, '</tr>');
            end;
            Writeln(F, '</table>');

            //  =====================================================
            //   6 
            DoMessage('r[R}ho͒...', 1);

    //  GOTO HELL
    HELL_HELL_HELL:

*)    
end;

//-----------------------------------------------------------------------------
//  HTML̃wb_o
procedure TAdoxJetHtml.PutHtmlHead(const FileName: string);
begin
    Writeln(F, '<!DOCTYPE html PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">');
    Writeln(F, '<html lang="ja"><head>');
    Writeln(F, '<meta http-equiv="Content-Type" content="text/html; charset=Shift_JIS">');
    Writeln(F, '<meta http-equiv="Content-Script-Type" content="text/javascript">');
    Writeln(F, '<meta http-equiv="Content-Style-Type" content="text/css">');
    Writeln(F, '<style type="text/css"><!--');
    Writeln(F, 'body,table{font-size:x-small;}body{font-family:sans-serif;}table{font-family:monospace;}');
    Writeln(F, '--></style>');

    Writeln(F, Format('<title>%s ͌</title>', [ExtractFileName(FileName)]));

    Writeln(F, '</head><body><p id="page_top">');

    Writeln(F, Format('<h1>%s ͌</h1>', [ExtractFileName(FileName)]));
    Writeln(F, Format('<p>Generated by %s at %s', [ExtractFileName(ParamStr(0)), FormatDateTime('yyyy/mm/dd hh:nn:ss', Now())]));
    Writeln(F, '<br>1) e[u\̃^CgɂuPKvuFKvuUKv͂ꂼuL[vuOL[vuӃL[vӖ܂B');
    Writeln(F, '<br>2) e[u\̃^CgɂuDXv́uCfbNXvӖ܂B');
end;

//-----------------------------------------------------------------------------
//  HTML̃tb^o
procedure TAdoxJetHtml.PutHtmlFoot();
begin
    Writeln(F, '<p><a href="#page_top">TOP</a></body></html>');
end;

//-----------------------------------------------------------------------------
//  e[uꗗo
procedure TAdoxJetHtml.PutTableItiran(const TABLES: OleVariant);
var
    i, j, TableCount: integer;
    TABLE, PROPS, PROP: OleVariant;
begin
    Writeln(F, '<h2>e[uꗗ</h2>');

    //  e[u邩ǂ`FbN
    TableCount := TABLES.Count;
    //  ΂邱ƂȂ
    if (TableCount = 0) then
    begin
        Writeln(F, '<p>e[u݂܂B');
        exit;
    end;

    Writeln(F, '<p><table border=1 cellpadding=3 cellspacing=0>');

    //  <TABLE>̌Œ^Cg쐬
    Write(F, '<tr><th nowrap>NO</th><th nowrap></th><th nowrap></th><th nowrap>쐬</th><th nowrap>XV</th>');

    //  <TABLE>̕^Cg쐬̂߂Ƀe[uIuWFNgo
    TABLE := TABLES.Item[0];

    //  vpeB񋓂
    PROPS := TABLE.Properties;
    for i := 0 to PROPS.Count - 1 do
    begin
        PROP := PROPS.Item[i];
        Write(F, Format('<th nowrap>%s</th>', [TransPropName(PROP.Name)]));
    end;
    Writeln(F, '</tr>');

    //  e[ũvpeBo
    for i := 0 to TableCount - 1 do
    begin
        //  e[uIuWFNgo
        TABLE := TABLES.Item[i];
        Writeln(F, '<tr>');
        //  ŒvpeBo
        Write(F, Format('<td nowrap>%d</td>', [i + 1]));
        Write(F, Format('<td nowrap>%s</td>', [TABLE.Name]));
        Write(F, Format('<td nowrap>%s</td>', [TABLE.type]));
        Write(F, Format('<td nowrap>%s</td>', [VarToStr(TABLE.DateCreated)]));
        Write(F, Format('<td nowrap>%s</td>', [VarToStr(TABLE.DateModified)]));
        //  vpeBo
        for j := 0 to PROPS.Count - 1 do
        begin
            PROP := PROPS.Item[j];
            Write(F, Format('<td nowrap>%s@</td>', [ChangeHTMLSpecialChar(PROP.Value)]));
        end;
        Writeln(F, '</tr>');
    end;
    Writeln(F, '</table>');
end;

//-----------------------------------------------------------------------------
//  tB[h\o
procedure TAdoxJetHtml.PutTableDetail(const TABLES: OleVariant);
var
    i, j, k, TableCount: integer;
    TABLE, PROPS, PROP: OleVariant;
    COLS, COL: OleVariant;
    S: string;
begin
    Writeln(F, '<h2>tB[h\</h2>');

    //  e[u邩ǂ`FbN
    TableCount := TABLES.Count;
    //  ΂邱ƂȂ
    if (TableCount = 0) then
    begin
        Writeln(F, '<p>e[u݂܂B');
        exit;
    end;

    //  ee[uƂɏo
    for i := 0 to TableCount - 1 do
    begin
        //  IuWFNgo
        TABLE := TABLES.Item[i];
        COLS  := TABLE.Columns;

        //  O
        PrepareTableSub(TABLE);

        //  ^Cgo
        DoMessage(Format('[%2d/%2d] %s', [i + 1, TableCount, TABLE.Name]), 2);
        Writeln(F, Format('<h3>%s</h3>', [TABLE.Name]));

        //  tB[h`FbN
        if (COLS.Count = 0) then
        begin
            Writeln(F, '<p>tB[h݂܂B');
            continue;
        end;

        //  <TABLE>̌Œ^Cg쐬
        Writeln(F, '<p><table border=1 cellpadding=3 cellspacing=0>');

        Writeln(F, '<tr><th nowrap>NO</th><th nowrap>PK</th><th nowrap>FK</th><th nowrap>UK</th><th nowrap>DX</th><th nowrap>񖼏</th><th nowrap>^</th><th nowrap></th><th nowrap>oCg</th><th nowrap>l^</th><th nowrap>x</th>');

        //  <TABLE>̕^Cg쐬̂߂ɃtB[hIuWFNgo
        COL := COLS.Item[0];
        PROPS := COL.Properties;
        //  vpeB񋓂
        for j := 0 to PROPS.Count - 1 do
        begin
            PROP := PROPS.Item[j];
            Write(F, Format('<th nowrap>%s</th>', [TransPropName(PROP.Name)]));
        end;
        Writeln(F, '</tr>');

        //  tB[h̃vpeBo
        for j := 0 to COLS.Count - 1 do
        begin
            //  tB[hIuWFNgo
            COL := COLS.Item[j];
            PROPS := COL.Properties;
            Writeln(F, '<tr>');
            //  ŒvpeBo
            Write(F, Format('<td nowrap>%d</td>', [j + 1]));

            //  L[?
            S := FTablePK.Values[COL.Name];
            if (S = '') then S := '@' else S := '';
            Write(F, Format('<td nowrap>%s</td>', [S]));
            //  OL[?
            S := FTableFK.Values[COL.Name];
            if (S = '') then S := '@' else S := '' + S;
            Write(F, Format('<td nowrap>%s</td>', [S]));
            //  j[NL[?
            S := FTableUK.Values[COL.Name];
            if (S = '') then S := '@' else S := '';
            Write(F, Format('<td nowrap>%s</td>', [S]));
            //  CfbNX?
            S := FTableIndex.Values[COL.Name];
            if (S = '') then S := '@' else S := '';
            Write(F, Format('<td nowrap>%s</td>', [S]));

            Write(F, Format('<td nowrap>%s</td>', [COL.Name]));
            Write(F, Format('<td nowrap>%s</td>', [DataTypeEnum2Str(COL.Type)]));
            Write(F, Format('<td nowrap>%s</td>', [ColumnAttributesEnum2Str(COL.Attributes)]));
            Write(F, Format('<td nowrap>%s</td>', [COL.DefinedSize]));
            Write(F, Format('<td nowrap>%s</td>', [COL.NumericScale]));
            Write(F, Format('<td nowrap>%s</td>', [COL.Precision]));
            //  vpeBo
            for k := 0 to PROPS.Count - 1 do
            begin
                PROP := PROPS.Item[k];
                Write(F, Format('<td nowrap>%s@</td>', [ChangeHTMLSpecialChar(PROP.Value)]));
            end;
            Writeln(F, '</tr>');
        end;
        Writeln(F, '</table>');
        //  lo
        Writeln(F, FTableMisc.Text);
    end;
end;

//-----------------------------------------------------------------------------
//  L[񏀔
procedure TAdoxJetHtml.PrepareTableSub(const TABLE: OleVariant);
var
    i, j: integer;
    KEYS, KEY, COLS, COL: OleVariant;
    INDEXES, INDEX: OleVariant;
    S, Line: string;
begin
    FTablePK.Clear;
    FTableFK.Clear;
    FTableUK.Clear;
    FTableMisc.Clear;
    FTableIndex.Clear;

    //  L[
    KEYS := TABLE.Keys;
    for i := 0 to KEYS.Count - 1 do
    begin
        KEY := KEYS.Item[i];
        COLS := KEY.Columns;

        for j := 0 to COLS.Count - 1 do
        begin
            COL := COLS.Item[j];

            case Integer(KEY.type) of

            adKeyPrimary:
                begin
                    FTablePK.Values[COL.Name] := '*';
                end;

            adKeyForeign:
                begin
                    S := Format('(*%d)', [FTableMisc.Count + 1]);
                    FTableFK.Values[COL.Name] := S;
                    Line := Format('N:%s.%s/폜[:%s/XV[:%s',
                                  [KEY.RelatedTable, COL.RelatedColumn,
                                   S_RuleEnum[Integer(KEY.DeleteRule)], S_RuleEnum[Integer(KEY.UpdateRule)]]);
                    FTableMisc.Add(Format('<br>%s%s', [S, Line]));
                end;

//            adKeyUnique:
            else
                begin
                    FTableUK.Values[COL.Name] := '*';
                end;

            end;
        end;
    end;

    //  CfbNX
    INDEXES := TABLE.Indexes;
    for i := 0 to KEYS.Count - 1 do
    begin
        INDEX := INDEXES.Item[i];
        COLS := INDEX.Columns;

        for j := 0 to COLS.Count - 1 do
        begin
            COL := COLS.Item[j];
            FTableIndex.Add(Format('%s=%s', [COL.Name, '*']));
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  ڑvpeBo
procedure TAdoxJetHtml.PutConnectionProp();
var
    i: integer;
    PROPS, PROP: OleVariant;
begin
    Writeln(F, '<h2>ڑ̃vpeB</h2>');
    Writeln(F, '<p><table border=1 cellpadding=3 cellspacing=0>');
    Writeln(F, '<tr><th nowrap>NO</th><th nowrap>vpeB</th><th nowrap>ݒl</th></tr>');

    PROPS := CNN.Properties;
    for i := 0 to PROPS.Count - 1 do
    begin
        PROP := PROPS.Item[i];
        Writeln(F, Format('<tr><td nowrap>%d</td><td nowrap>%s</td><td nowrap>%s@</td></tr>',
                          [i + 1, TransPropName(PROP.Name), ChangeHTMLSpecialChar(PROP.Value)])
               );
    end;
    Writeln(F, '</table>');
end;


//-----------------------------------------------------------------------------
initialization
    CoInitialize(nil);
finalization
    CoUninitialize();
end.

